package consume

import (
	utils2 "applet/app/utils"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/md"
	es2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/utils/es"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_es.git/es"
	"context"
	"fmt"
	"github.com/olivere/elastic/v7"
	"strings"
	"testing"
	"time"
)

func TestEs(t *testing.T) {
	es.Init("http://123.57.140.192:9200", "elastic", "fnuo123")
	year, week := time.Now().ISOWeek()
	yearStr := utils2.IntToStr(year)
	weekStr := utils2.IntToStr(week)
	index := es2.GetAppointIndexFromAlias(yearStr, weekStr)
	amount := utils2.StrToFloat64("100")
	uid := "100"
	id := fmt.Sprintf("%d%d_%s", year, week, uid)
	script := elastic.NewScript("ctx._source.person_add_activity_value += params.inc").Param("inc", int(amount))
	updateDoc, err := es.EsClient.Update().
		Index(index).
		Id(id).
		Script(script).
		Do(context.Background())
	now := time.Now().Format("2006-01-02 15:04:05")
	if err != nil {
		if strings.Contains(err.Error(), "elastic: Error 404 (Not Found)") {
			// 如果记录不存在就创建记录
			m := md.EggEnergyUserEggScoreEs{
				Uid:                                 utils2.StrToInt64(uid),
				ScoreValue:                          0,
				ScoreValueKind:                      0,
				Ecpm:                                0,
				InviteUserNums:                      0,
				TeamActivityNums:                    0,
				SignInNums:                          0,
				ImActivityNums:                      0,
				SendRedPackageNums:                  0,
				EggEnergyExchangeAccountBalance:     0,
				AccountBalanceExchangeEggEnergyNums: 0,
				SendCircleOfFriendNums:              0,
				ForumCommentsNums:                   0,
				CollegeLearningNums:                 0,
				ViolateNums:                         0,
				BrowseInterfaceNums:                 0,
				PersonAddActivityValue:              1,
				CreatedAt:                           now,
				UpdatedAt:                           now,
			}
			createDoc, err1 := es.CreateDoc(index, id, m)
			if err1 != nil {
				fmt.Println("EggCanalPersonAddActivityValueConsumeCreateDoc_ERR::::", err1.Error())
				return
			}
			fmt.Println("createDoc==========>", createDoc)
			return
		}
		fmt.Println("EggCanalPersonAddActivityValueConsumeUpdateDoc_ERR::::", err.Error())
	}
	fmt.Println("updateDoc==========>", updateDoc)
}
