package consume

import (
	"applet/consume/md"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"testing"
	"time"
)

func TestSendMessageToUserVirtualCoinFlowAggregationConsume(t *testing.T) {
	data := md.CanalUserVirtualCoinFlowAggregation{
		Id:           "1",
		Uid:          "19",
		CoinId:       "1",
		Direction:    "1",
		Title:        "兑换到个人蛋蛋能量",
		Amount:       "40",
		BeforeAmount: "0",
		AfterAmount:  "80",
		SysFee:       "0",
		TransferType: "6",
	}

	message := md.CanalUserVirtualCoinFlowAggregationMessage[md.CanalUserVirtualCoinFlowAggregation]{
		Data:     []md.CanalUserVirtualCoinFlowAggregation{data},
		Database: "test_db",
		ES:       time.Now().UnixNano(),
		ID:       1,
		IsDdl:    false,
		Old:      nil,
		PkNames:  []string{"id"},
		Table:    "user_virtual_coin_flow",
		TS:       time.Now().Unix(),
		Type:     "INSERT",
	}

	err := rabbit.Init("120.77.153.180", "5672", "guest", "guest")
	if err != nil {
		return
	}
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		return
	}
	defer ch.Release()
	ch.Publish(md2.EggCanalExchange, message, "egg_canal_user_virtual_coin_flow")

}
